#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <set>

using namespace std;

const int NMAX=1000000;
int n, min_val, max_val;
set<int, less<int> > s;
typedef set<int, less<int> > :: iterator SIT;
SIT sit;

//аргументы: количество_запросов, начальное_значение_для_srand, минимальное_значение_элемента, максимальное_значение_элемента
int main (int, char *argv[]) {
  n = atoi(argv[1]);
  int srand_init = atoi(argv[2]);
  min_val = atoi(argv[3]);
  max_val = atoi(argv[4]);
  srand(srand_init);
  cout << n << endl;
  for (int i=0; i<n; ) {
    int q_type = rand() % 3;
    int v;
    switch(q_type) {
      case 0: //ADD
        v = rand() * rand() % (max_val-min_val+1) + min_val;
        cout << "ADD " << v << endl;
        if (s.count(v) == 0)
          s.insert(v);
        i++;
        break;
      case 1: //DEL
        v = rand() * rand() % (max_val-min_val+1) + min_val;        
        cout << "DEL " << v << endl;
        s.erase(v);
        i++;
        break;
      case 2: //FIND
        if (s.size() < 2) continue;
        cout << "FIND" << endl;
        i++;
    }
  }
  return 0;
}

